/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.KelompokPegawaiDao;
import com.portofolio.dto.KelompokPegawaiDto;
import com.portofolio.entity.KelompokPegawai;
import com.portofolio.entity.vo.KelompokPegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class KelompokPegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private KelompokPegawaiDao kelompokPegawaiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(KelompokPegawaiDto kelompokPegawaiDto) {
		result.clear();
		KelompokPegawaiId id = new KelompokPegawaiId();
		String kdKelompokPegawai =getIdTerahir(KelompokPegawai.class.getSimpleName(), 2);
		id.setKdKelompokPegawai(kdKelompokPegawai);
		id.setKdProfile(getKdProfile());
		KelompokPegawai kelompokPegawai = CommonUtil.findOne(kelompokPegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(kelompokPegawai)) {
			kelompokPegawai = new KelompokPegawai();
			BeanUtils.copyProperties(kelompokPegawaiDto, kelompokPegawai);
			kelompokPegawai.setNoRec(generateUuid32());
			kelompokPegawai.setVersion(1);
			kelompokPegawai.setId(id);
			kelompokPegawai = kelompokPegawaiDao.save(kelompokPegawai);
			result.put("kelompokPegawai", kelompokPegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("kelompokPegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(KelompokPegawaiDto kelompokPegawaiDto, String kdKelompokPegawai, Integer version) {
		result.clear();
		KelompokPegawaiId id = new KelompokPegawaiId();
		id.setKdKelompokPegawai(kdKelompokPegawai);
		id.setKdProfile(getKdProfile());
		KelompokPegawai kelompokPegawai = CommonUtil.findOne(kelompokPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(kelompokPegawai)) {
			if (version < kelompokPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(kelompokPegawaiDto, kelompokPegawai);
			kelompokPegawai.setVersion(version);
			kelompokPegawai = kelompokPegawaiDao.save(kelompokPegawai);
			result.put("kelompokPegawai", kelompokPegawai);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaKelompokPegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaKelompokPegawai)) {
			pageRes = kelompokPegawaiDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = kelompokPegawaiDao.findAllList(getKdProfile(), namaKelompokPegawai, statusEnabled, pageReq);
		}
		result.put("kelompokPegawai", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdKelompokPegawai(String kdKelompokPegawai) {
		result.clear();
		result.put("kelompokPegawai", kelompokPegawaiDao.findByKdKelompokPegawai(getKdProfile(), kdKelompokPegawai, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdKelompokPegawai, Integer version) {
		result.clear();
		KelompokPegawaiId id = new KelompokPegawaiId();
		id.setKdKelompokPegawai(kdKelompokPegawai);
		id.setKdProfile(getKdProfile());
		KelompokPegawai kelompokPegawai = CommonUtil.findOne(kelompokPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(kelompokPegawai)) {
			if (version < kelompokPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			kelompokPegawai.setStatusEnabled(false);
			kelompokPegawai.setVersion(version);
			kelompokPegawai = kelompokPegawaiDao.save(kelompokPegawai);
			result.put("kelompokPegawai", kelompokPegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
